/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

#ifndef MTK_BUTTON_H
#define MTK_BUTTON_H

#if 1//3key
static MULTI_KEY_T _arMTKMultiKeyList[] = {
    { BTN_FUNCTION_1,       (DKBIT_VOL_DOWN | DKBIT_CENTER) },
	{ BTN_FUNCTION_7,       (DKBIT_VOL_UP | DKBIT_CENTER) },
    { BTN_NONE,             (DKBIT_NONE) },
};

static SGL_SERVO_T _arMTKSingleServoKey[] = {
    {   SERVO(6),   141,    76,     DKBIT_VOL_UP},      //  101  // 102
    {   SERVO(6),    75,    0,      DKBIT_VOL_DOWN},    //  162  // 164
    {   0,          0,      0,      BTN_NONE},
};

static SGL_GPIO_T _arMTKSingleGpioKey[] = {
    // GPIO,       Btm,    Key
    { OPCTRL(7),   0,    DKBIT_CENTER},
    {   0,         0,    DKBIT_NONE  },
};
#else//4key
static MULTI_KEY_T _arMTKMultiKeyList[] = {
    { BTN_FACTORY_MODE_1,   (DKBIT_VOL_DOWN | DKBIT_INPUT_SRC) },
    { BTN_FUNCTION_1,       (DKBIT_VOL_DOWN | DKBIT_POWER) },
    { BTN_NONE,             (DKBIT_NONE) },
};

static SGL_SERVO_T _arMTKSingleServoKey[] = {
    {   SERVO(6),   185,   126,     DKBIT_INPUT_SRC},   //  8    // 39
    {   SERVO(6),   125,    76,     DKBIT_VOL_UP},      //  101  // 102
    {   SERVO(6),    75,    0,      DKBIT_VOL_DOWN},    //  162  // 164
    {   0,          0,      0,      BTN_NONE},
};

static SGL_GPIO_T _arMTKSingleGpioKey[] = {
    // GPIO,       Btm,    Key
    { OPCTRL(7),   0,    DKBIT_POWER },
    {   0,         0,    DKBIT_NONE  },
};
#endif

static COMB_IR_KP_T _arSonyCOMBOKeyList[] = {
    { BTN_FUNCTION_8, BTN_CURSOR_UP,   (BTN_FUNCTION_6 | KEY_SRC_FRONT_PANEL)},
};

#define SINGLE_GPIO_KEY_LIST			(_arMTKSingleGpioKey)
#define SINGLE_SERVO_KEY_LIST			(_arMTKSingleServoKey)
#define MULTI_KEY_LIST					(_arMTKMultiKeyList)

#define COMB_KEY_LIST					(_arSonyCOMBOKeyList)

#endif /* MTK_BUTTON_H */

