#ifndef FLASH_LAYOUT_H
#define FLASH_LAYOUT_H

//----------------------------------------------------------------------------
// NAND customization
//----------------------------------------------------------------------------
    /* IPTV */
	#define NAND_FLASH_TOTAL_SIZE            ((UINT64)2*1024*1024*1024)
	
    /* A temporary change for 3rd size is not enough in cli pkg */
    #ifdef CC_ENLARGE_3RD_SIZE	
        #define NAND_FLASH_3RD_SIZE 			(528*1024*1024) 	/* 498 MB */

		#if defined(REPLACE_EEPROM_WITH_FLASH) || defined(REPLACE_EEPROM_WITH_EMMC) || defined(REPLACE_EEPROM_WITH_NOR)
        #define NAND_FLASH_3RD_RW_SIZE			(35*1024*1024) 	/* 138 MB - 20 MB(virtual eeprom) */
		#else
		#define NAND_FLASH_3RD_RW_SIZE			(200*1024*1024) 	/* 138 MB */
		#endif /*REPLACE_EEPROM_WITH_FLASH*/

    #else
		#ifndef SYS_3RD_RO_UBIFS
			#define NAND_FLASH_3RD_SIZE 			(168*1024*1024) 	/* 168 MB */
        #else
			#define NAND_FLASH_3RD_SIZE 			(146*1024*1024) 	/* 146 MB for BZ TOTVS Ginga debug */
		#endif
	
	    #ifdef CC_ENLARGE_APPIMAGE_SIZE
			#if defined(REPLACE_EEPROM_WITH_FLASH) || defined(REPLACE_EEPROM_WITH_EMMC) || defined(REPLACE_EEPROM_WITH_NOR)
	        #define NAND_FLASH_3RD_RW_SIZE          (262*1024*1024)     /* 200 MB - 20 MB(virtual eeprom) */
	        #else
	        #define NAND_FLASH_3RD_RW_SIZE          (282*1024*1024)     /* 210 MB */
	        #endif /*REPLACE_EEPROM_WITH_FLASH*/    
	    #else    
	        #if defined(REPLACE_EEPROM_WITH_FLASH) || defined(REPLACE_EEPROM_WITH_EMMC) || defined(REPLACE_EEPROM_WITH_NOR)
				#ifndef SYS_3RD_RO_UBIFS
					#define NAND_FLASH_3RD_RW_SIZE			(200*1024*1024) 	/* 200 MB */
				#else
					#define NAND_FLASH_3RD_RW_SIZE			(262*1024*1024) 	/* 200 MB - 20 MB(virtual eeprom) for BZ TOTVS Ginga debug */
				#endif
	        #else
	        #define NAND_FLASH_3RD_RW_SIZE			(238*1024*1024) 	/* 238 MB */
	        #endif /*REPLACE_EEPROM_WITH_FLASH*/	
	    #endif
    #endif /*CC_ENLARGE_3RD_SIZE*/

    #ifdef CC_DISABLE_BASIC_PART
    #define NAND_FLASH_ROOTFS_SIZE          (65*1024*1024)         /*  65 MB */ /* Normal behavior */
    #define NAND_FLASH_APPIMAGE_SIZE        (1*1024*1024)          /* 256 KB */ /* Normal behavior */
    #else
        #define NAND_FLASH_ROOTFS_SIZE          (8*1024*1024)       /*   8 MB */ /* Debug+Development purpose */
        #ifdef CC_ENLARGE_APPIMAGE_SIZE
        #define NAND_FLASH_APPIMAGE_SIZE        (135*1024*1024)      /*  70 MB =>135 MB*/ /* Debug+Development purpose */
        #else
        #define NAND_FLASH_APPIMAGE_SIZE        (52*1024*1024)      /*  52 MB */ /* Debug+Development purpose */
        #endif
    #endif

#define NAND_FLASH_LOADER_SIZE              (2*1024*1024)          /* 2 MB */
#define NAND_FLASH_UBOOT_SIZE               (2*1024*1024)          /* 2 MB */
#define NAND_FLASH_SIGNATURE_SIZE           (1*1024*1024)          /* 2 MB */
#define NAND_FLASH_KERNEL_SIZE              (4*1024*1024)          /* 3 MB */
#define NAND_FLASH_PERM_SIZE                (8*1024*1024)          /* 8 MB */
#define NAND_FLASH_SINGLE_CHANNELLIST_SIZE  (1*1024*1024)          /* 512 KB to support 5000 channels */
#define NAND_FLASH_PQ_SIZE                  (30*1024*1024)         /* 5 MB */
#define NAND_FLASH_AQ_SIZE                  (5*1024*1024)          /* 5 MB */
#define NAND_FLASH_PANEL_SIZE               (1*1024*1024)          /* 1 MB */
#define NAND_FLASH_CIPLUS_SIZE              (1*1024*1024)          /* 1 MB */
#define NAND_FLASH_EDID_SIZE                (1*1024*1024)          /* 1 MB */
#define NAND_FLASH_SERVICE_MODE_SIZE        (1*1024*1024)          /* 1 MB */
#define NAND_FLASH_DVBS_DEFAULT_DB_SIZE     (1*1024*1024)          /* 1 MB */
#define NAND_FLASH_EPG_CACHE_SIZE           (1*1024*1024)          /* 1 MB */
#define NAND_FLASH_HDMI_SIZE                (1*1024*1024)          /* 1 MB */
#define NAND_FLASH_WFDP_SIZE                (1*1024*1024)          /* 1 MB */
#define NAND_FLASH_BECHIP_SIZE              (1*1024*1024)          /* 1 MB */ //pwh for bechip
#ifdef CC_ENLARGE_3RD_SIZE
#define NAND_FLASH_UPG_SIZE                 (105*1024*1024)        /* 100 MB =>45 MB */
#else
#define NAND_FLASH_UPG_SIZE                 (300*1024*1024)        /* 300 MB */
#endif
#define NAND_FLASH_RESERVED_SIZE            (20*1024*1024)         /* 20 MB Reserved for future */
//#define NAND_PART_MAX_IMG_SIZE              (40*1024*1024)      /*  40 MB */
#if defined(REPLACE_EEPROM_WITH_FLASH) || defined(REPLACE_EEPROM_WITH_EMMC) || defined(REPLACE_EEPROM_WITH_NOR)
#define NAND_FLASH_REPLACE_EEPROM_SIZE      (1*1024*1024)          /* EMMC for eeprom */
#endif
#define NAND_FLASH_PQ_EEP_BACKUP_SIZE       (1*1024*1024)          /* 1 MB */
#define NAND_FLASH_RESERVE_SIZE             (1*1024*1024)          /* 1 MB */

#ifdef ADSP_BIN_SUPPORT
	#define NAND_FLASH_ADSP_SIZE            (6*1024*1024)          /* 6 MB audio dsp size */
#else
	#define NAND_FLASH_ADSP_SIZE            (NAND_FLASH_RESERVE_SIZE)
#endif
#define NAND_FLASH_SAPOST_SIZE              (1*1024*1024)          /* 1 MB */
#define NAND_FLASH_FDAT_SIZE                (1*1024*1024)          /* 1 MB */
#define NAND_FLASH_SPQD_SIZE                (2*1024*1024)          /* 2 MB */
#define NAND_FLASH_SPQC_SIZE                (5*1024*1024)          /* 5 MB */
#define NAND_FLASH_FACTORY_SIZE             (1*1024*1024)          /* 1 MB */
#define NAND_FLASH_CACHE_SIZE               (692*1024*1024)        /* 692 MB */
#define NAND_FLASH_WARMBOOT_SIZE            (128*1024*1024)        /* 128 MB */

#define NAND_PART_SIZE_0                    (NAND_FLASH_LOADER_SIZE)                /* loader image                  */
#define NAND_PART_SIZE_1                    (NAND_FLASH_UBOOT_SIZE)                 /* nand_1  - uboot env           */
#define NAND_PART_SIZE_2                    (NAND_FLASH_SIGNATURE_SIZE)             /* nand_2  - sig A               */
#define NAND_PART_SIZE_3                    (NAND_FLASH_SIGNATURE_SIZE)             /* nand_3  - sig B               */
#if defined(REPLACE_EEPROM_WITH_FLASH) || defined(REPLACE_EEPROM_WITH_EMMC) || defined(REPLACE_EEPROM_WITH_NOR)
#define NAND_PART_SIZE_4                  (NAND_FLASH_REPLACE_EEPROM_SIZE)        /* nand_29 - EEPROM A            */
#define NAND_PART_ID_EEPROM_A               (4)
#endif
#define NAND_PART_SIZE_5                   (NAND_FLASH_PERM_SIZE)                   /* nand_10 - perm                */
#define NAND_PART_SIZE_6                   (NAND_FLASH_CIPLUS_SIZE)                 /* nand_20 - ci                  */
#define NAND_PART_SIZE_7                   (NAND_FLASH_HDMI_SIZE)                   /* nand_25 - HDMI HDCP           */
#define NAND_PART_SIZE_8                   (NAND_FLASH_WFDP_SIZE)                   /* nand_26 - Miracast HDCP       */
#define NAND_PART_SIZE_9                   (NAND_FLASH_KERNEL_SIZE)                 /* nand_4  - kernel A            */
#define NAND_PART_SIZE_10                  (NAND_FLASH_KERNEL_SIZE)                 /* nand_5  - kernel B            */
#define NAND_PART_SIZE_11                  (NAND_FLASH_ROOTFS_SIZE)                 /* nand_6  - rootfs A            */
#define NAND_PART_SIZE_12                  (NAND_FLASH_ROOTFS_SIZE)                 /* nand_7  - rootfs B            */
#define NAND_PART_SIZE_13                  (NAND_FLASH_APPIMAGE_SIZE)               /* nand_8  - basic               */
#define NAND_PART_SIZE_14                  (NAND_FLASH_3RD_RW_SIZE)                 /* nand_9  - 3rd_rw              */
#define NAND_PART_SIZE_15                   (NAND_FLASH_UPG_SIZE)                   /* nand_11 - NDD upgrade             */
#define NAND_PART_SIZE_16                   (NAND_FLASH_3RD_SIZE)                   /* nand_12 - 3rd_ro              */
#define NAND_PART_SIZE_17                   (NAND_FLASH_SINGLE_CHANNELLIST_SIZE)    /* nand_13 - channel list A      */
#define NAND_PART_SIZE_18                   (NAND_FLASH_SINGLE_CHANNELLIST_SIZE)    /* nand_14 - channel list B      */
#define NAND_PART_SIZE_19                   (NAND_FLASH_PQ_SIZE)                    /* nand_15 - Flash PQ            */
#define NAND_PART_SIZE_20                   (NAND_FLASH_PQ_SIZE)                    /* nand_16 - Flash PQ            */
#define NAND_PART_SIZE_21                   (NAND_FLASH_AQ_SIZE)                    /* nand_17 - Flash AQ            */
#define NAND_PART_SIZE_22                   (NAND_FLASH_AQ_SIZE)                    /* nand_18 - Flash AQ            */
#define NAND_PART_SIZE_23                   (NAND_FLASH_PANEL_SIZE)                 /* nand_19 - Flash Panel         */
#define NAND_PART_SIZE_24                   (NAND_FLASH_EDID_SIZE)                  /* nand_21 - edid                */
#define NAND_PART_SIZE_25                   (NAND_FLASH_SERVICE_MODE_SIZE)          /* nand_22 - Service mode        */
#define NAND_PART_SIZE_26                   (NAND_FLASH_DVBS_DEFAULT_DB_SIZE)       /* nand_23 - DVBS Default DB     */
#define NAND_PART_SIZE_27                   (NAND_FLASH_EPG_CACHE_SIZE)             /* nand_24 - EPG Cache           */
#define BECHIP_INITDATA_NAND_PART_ID  (28)
#define NAND_PART_SIZE_28                   (NAND_FLASH_BECHIP_SIZE)                /* nand_27 - BEchip              */ //pwh for bechip
#define NAND_PART_ID_PQ_EEP_BACKUP              (29)
#define NAND_PART_SIZE_29                       (NAND_FLASH_PQ_EEP_BACKUP_SIZE) 

#ifdef ADSP_BIN_SUPPORT
#define NAND_PART_SIZE_30                   (NAND_FLASH_ADSP_SIZE)                  /* nand_30 - ADSP bin             */
#define NAND_PART_SIZE_31                   (NAND_FLASH_ADSP_SIZE)                  /* nand_31 - ADSP bin             */
#endif

#if 1//def RESERVE_PARTITON
#define NAND_PART_SIZE_32				(NAND_FLASH_SAPOST_SIZE)
#define NAND_PART_SIZE_33				(NAND_FLASH_SAPOST_SIZE)
#define NAND_PART_SIZE_34				(NAND_FLASH_FDAT_SIZE)
#define NAND_PART_SIZE_35				(NAND_FLASH_SPQD_SIZE)
#define NAND_PART_SIZE_36				(NAND_FLASH_SPQD_SIZE)
#define NAND_PART_SIZE_37				(NAND_FLASH_SPQC_SIZE)
#define NAND_PART_SIZE_38				(NAND_FLASH_SPQC_SIZE)
#define NAND_PART_SIZE_39				(NAND_FLASH_FACTORY_SIZE)
#define NAND_PART_SIZE_40				(NAND_FLASH_CACHE_SIZE)
#define NAND_PART_SIZE_41				(NAND_FLASH_RESERVED_SIZE)
#define NAND_PART_SIZE_42				(NAND_FLASH_WARMBOOT_SIZE)
#endif
#define NAND_PART_ENCRYPT_0                (0)   
#define NAND_PART_ENCRYPT_1                (0)                 /* uboot */
#define NAND_PART_ENCRYPT_2                (0)      
#define NAND_PART_ENCRYPT_3                (0)      
#define NAND_PART_ENCRYPT_4                (0)      
#define NAND_PART_ENCRYPT_5                (1)                  /* perm */
#define NAND_PART_ENCRYPT_6                (0)      
#define NAND_PART_ENCRYPT_7                (0)      
#define NAND_PART_ENCRYPT_8                (0)      
#define NAND_PART_ENCRYPT_9                (1)
#define NAND_PART_ENCRYPT_10                (1)
#define NAND_PART_ENCRYPT_11                (1)                 /* rootfs */                
#define NAND_PART_ENCRYPT_12                (1)                 /* rootfs */
#define NAND_PART_ENCRYPT_13                (0)      
#define NAND_PART_ENCRYPT_14                (1)                 /* 3rd_rw */      
#define NAND_PART_ENCRYPT_15                (1)                 /* NDD upgrade */
#define NAND_PART_ENCRYPT_16                (1)                 /* 3rd ro */
#define NAND_PART_ENCRYPT_17                (0)      
#define NAND_PART_ENCRYPT_18                (0)      
#define NAND_PART_ENCRYPT_19                (0)       
#define NAND_PART_ENCRYPT_42                (1) 

/* The NAND_PART_NAME_0-7 use default names. */
#define NAND_PART_NAME_4			        "eepromA"
#define NAND_PART_NAME_5			        "perm"
#define NAND_PART_NAME_6			        "ci"
#define NAND_PART_NAME_7			        "hdmi"
#define NAND_PART_NAME_8			        "wfdp"
#define NAND_PART_NAME_9                    "kernelA"
#define NAND_PART_NAME_10                   "kernelB"
#define NAND_PART_NAME_11                   "rootfsA"
#define NAND_PART_NAME_12                   "rootfsB"
#define NAND_PART_NAME_13                   "basic"
#define NAND_PART_NAME_14                   "3rd_rw"
#define NAND_PART_NAME_15                   "upgrade"
#define NAND_PART_NAME_16                   "3rd_ro"
#define NAND_PART_NAME_17                   "channelA"
#define NAND_PART_NAME_18                   "channelB"
#define NAND_PART_NAME_19                   "pqa"
#define NAND_PART_NAME_20                   "pqb"
#define NAND_PART_NAME_21                   "aqa"
#define NAND_PART_NAME_22                   "aqb"
#define NAND_PART_NAME_23                   "panel"
#define NAND_PART_NAME_24                   "edid"
#define NAND_PART_NAME_25                   "svc"
#define NAND_PART_NAME_26                   "ddb"
#define NAND_PART_NAME_27                   "epg"
#define NAND_PART_NAME_28                   "bechip"
#define NAND_PART_NAME_29                   "pqeepback" //only one eeprom

#ifdef ADSP_BIN_SUPPORT	
#ifndef CC_MTK_LOADER
#define FLASH_ADSP_BIN_PARTITION_A       (30)   //bank A;  bank B= bank A +1 
#define FLASH_ADSP_BIN_PARTITION                 (((DRVCUST_GetDTVCfg() & DTVCFG_FLAG3_ROOTFS_BANK)==DTVCFG_FLAG3_ROOTFS_BANK)?(FLASH_ADSP_BIN_PARTITION_A+1):(FLASH_ADSP_BIN_PARTITION_A))	
#define NAND_PART_NAME_30           	"adspa"
#define NAND_PART_NAME_31				"adspb"
#endif
#endif


#if 1//def RESERVE_PARTITON
#define NAND_PART_NAME_32				"spsA"
#define NAND_PART_NAME_33				"spsB"
#define NAND_PART_NAME_34				"fdat"
#define NAND_PART_NAME_35				"spdA"
#define NAND_PART_NAME_36				"spdB"
#define NAND_PART_NAME_37				"spcA"
#define NAND_PART_NAME_38				"spcB"
#define NAND_PART_NAME_39				"fnvm"
#define NAND_PART_NAME_40				"cach"
#define NAND_PART_NAME_41				"reserved"
#define NAND_PART_NAME_42				"warm"
#endif
#define NAND_FLASH_STATIC_LAST_PART_ID      (12)

#if defined(REPLACE_EEPROM_WITH_FLASH) || defined(REPLACE_EEPROM_WITH_EMMC) || defined(REPLACE_EEPROM_WITH_NOR)
#if 1//def RESERVE_PARTITON
#define NAND_PART_END                       (42)                /* total 29 Partitions with REPLACE_EEPROM_WITH_FLASH */
#else
#define NAND_PART_END                       (31)                /* total 29 Partitions with REPLACE_EEPROM_WITH_FLASH */
#endif
#endif

#define NAND_FLASH_STATIC_PART_SIZE \
        ((NAND_PART_SIZE_0) + \
        (NAND_PART_SIZE_1) + (NAND_PART_SIZE_2) + (NAND_PART_SIZE_3) + \
        (NAND_PART_SIZE_4) + (NAND_PART_SIZE_5) + (NAND_PART_SIZE_6) + \
        (NAND_PART_SIZE_7) + (NAND_PART_SIZE_8) + (NAND_PART_SIZE_9) + \
        (NAND_PART_SIZE_10) + (NAND_PART_SIZE_11) + (NAND_PART_SIZE_12))

/*Flash PQ customization*/
#ifdef SUPPORT_FLASH_PQ
#define FLASH_PQ_USE_NAND_FLASH                 (1)
#ifndef CC_MTK_LOADER
extern UINT8 DRVCUST_GetDTVCfg(void);
#define FLASH_PQ_BASE_PARTITION_A               (19)   //bank A;  bank B= bank A +1
#define FLASH_PQ_BASE_PARTITION                 (((DRVCUST_GetDTVCfg() & DTVCFG_FLAG3_ROOTFS_BANK)==DTVCFG_FLAG3_ROOTFS_BANK)?(FLASH_PQ_BASE_PARTITION_A+1):(FLASH_PQ_BASE_PARTITION_A))
#endif

#ifndef DEMO_BOARD
/* customer */
#define SUPPORT_FLASH_PQ_ENABLE_QTY_SMART_PIC   (1)
#define SUPPORT_FLASH_PQ_ENABLE_GAMMA           (1)
#define SUPPORT_FLASH_PQ_ENABLE_QTY_MAX_MIN     (1)
#define SUPPORT_NVM_GAMMA                       (1)
#endif
#endif

#ifdef SUPPORT_FLASH_AQ
#define FLASH_AQ_BASE_PARTITION               (21)   //bank A;  bank B= bank A +1
#define FLASH_AQ_BASE_ADDRESS               (0)
#endif

/* Flash Panel Table */
#ifdef CC_PANEL_FROM_FLASH
#ifdef CC_SOEM_BOARD
#define PANEL_FLASH_HEADER_ADDRESS          (0)
#define PANEL_FLASH_HEADER_LENGTH           (32)
#define PANEL_FLASH_TABLE_SIZE              (287)
#define PANEL_FLASH_TABLE_BASE_PARTITION    (23)
#define PANEL_FLASH_TABLE_ADDRESS           (32)
#endif
#endif

/* Flash EDID */
#define HDMIEDID_NAND_FLASH_PART_ID         (24)
#define HDMIEDID_NAND_FLASH_OFFSET          (0)
#define HDMIEDID_NAND_FLASH_PART_SIZE       (NAND_FLASH_EDID_SIZE)
#define VGAEDID_NAND_FLASH_PART_ID          (21)
#define VGAEDID_NAND_FLASH_OFFSET           (0)
#define VGAEDID_NAND_FLASH_PART_SIZE        (NAND_FLASH_EDID_SIZE)

/* Flash HDCP */
#define HDCP_NAND_FLASH_PART_ID             (7)
#define HDCP_NAND_FLASH_OFFSET              (0)

#define HDCP2X_NAND_FLASH_PART_ID			(8)

#endif /* FLASH_LAYOUT_H */
