/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*************************************************************************
 *
 * Filename:
 * ---------
 *   $Workfile: drv_contrast.h $
 *
 * Project:
 * --------
 *
 *
 * Description:
 * ------------
 *
 *
 * Author:
 * -------
 *
 *
 * Last changed:
 * -------------
 * $Author: meijun.jiang $
 *
 * $Modtime: 04/05/23 2:49p $
 *
 * $Revision: #3 $
*************************************************************************/

#ifndef _DRV_CONTRAST_H_
#define _DRV_CONTRAST_H_

#include "general.h"
#include "drv_meter.h"


#define LUMA_HIST_NORM_BASE_BIT     9          
#define LUMA_HIST_NORM_BASE         (1<<LUMA_HIST_NORM_BASE_BIT)
#define LUMA_CURVE_NUM	            (LUMA_HIST_NUM+1)
#define LUMA_CURVE_NUM_65           (LUMA_HIST_NUM*2+1)
#define LUMA_CURVE_SKIN_NUM         LUMA_CURVE_NUM
#define LUMA_CURVE_SKIN_NUM_65      LUMA_CURVE_NUM_65

#define LUMA_HIST_NUM_TRUNCATE	    LUMA_HIST_NUM
#define HUE_HIST_NORM_BASE_BIT      8          
#define HUE_HIST_NORM_BASE          (1<<HUE_HIST_NORM_BASE_BIT)

EXTERN UINT16 waLumaArray[LUMA_CURVE_NUM_65];
EXTERN UINT16 waSecondLumaArray[LUMA_CURVE_NUM_65];

// ---- Adaptive luma -----
void vDrvADLInit(void);
void vDrvADLOnOff(UINT8 bOnOff);
void vDrvADLProc(void);
void vDrvAutoContrastFreeze(UINT8 bFreeze);
void vDrvADLSetYGamma(UINT8 bIndex);
void vDrvADLSetLumaCurve(const UINT16 *waLArray);
void vDrvADLSetLumaSecCurve(const UINT16* waLArray);
void vDrvADLGetLumaCurve(UINT16* waLArray);
void vDrvADLUpdateParam(void);
void vDrvADLManualLumaCurveOnOff(UINT8 bOnOff);
void vDrvADLUpdateLumaCurve(void);
void vDrvADLUpdateSecondLumaCurve(void);
void vDrvADLSetSecondLumaCurveHw(const UINT16 * waSLArray);
#if defined(CC_MT5883)||defined(CC_MT5882)
void vDrvADLSetLumaCurve65Hw(const UINT16 * waLArray);
void vDrvADLSetSecondLumaCurve65Hw(const UINT16 * waSLArray);
void vDrvADLSetLumaCurveMode(UINT8 value);
void vDrvADLSetYHistogramMode(UINT8 value);
UINT8 vDrvADLGetLumaCurveMode(void);
UINT8 vDrvADLGetYHistogramMode(void);
void vDrvADLSetLinearCurve65(void);
void vDrvADLSetLinearSecondCurve65(void);
void vDrvADLGetLumaCurve65(UINT16* waLArray);
void vDrvADLSetLumaCurve65(const UINT16* waLArray);
void vDrvADLSetLumaCurve33To65(const UINT16* waLArray32,UINT16* waLArray65);
#endif
void vDrvADLSetSecondLumaCurveHwExtend(const UINT16 * waSLArray);
void vDrvGetBlackWhite2BinSum(const UINT16 * waHistCur, UINT8 bMode);

#endif
